BN_CTX_new(3)

NAME
BN_CTX_new, BN_CTX_init, BN_CTX_free - allocate and free BN_CTX structures

SYNOPSIS
 #include <openssl/bn.h>

 BN_CTX *BN_CTX_new(void);

 void BN_CTX_init(BN_CTX *c);

 void BN_CTX_free(BN_CTX *c);

DESCRIPTION
A BN_CTX is a structure that holds BIGNUM temporary variables used by library functions. Since dynamic memory allocation to create BIGNUMs is rather expensive when used in conjunction with repeated subroutine calls, the BN_CTX structure is used.

BN_CTX_new() allocates and initializes a BN_CTX structure. BN_CTX_init() initializes an existing uninitialized BN_CTX.

BN_CTX_free() frees the components of the BN_CTX, and if it was created by BN_CTX_new(), also the structure itself. If BN_CTX_start(3) has been used on the BN_CTX, BN_CTX_end(3) must be called before the BN_CTX may be freed by BN_CTX_free().

RETURN VALUES
BN_CTX_new() returns a pointer to the BN_CTX. If the allocation fails, it returns NULL and sets an error code that can be obtained by ERR_get_error(3).

BN_CTX_init() and BN_CTX_free() have no return values.

SEE ALSO
bn(3), ERR_get_error(3), BN_add(3), BN_CTX_start(3)

HISTORY
BN_CTX_new() and BN_CTX_free() are available in all versions on SSLeay and OpenSSL. BN_CTX_init() was added in SSLeay 0.9.1b.